<CsoundSynthesizer>
<CsOptions>
-o dac -d --messagelevel=2
</CsOptions>
; ==============================================
<CsInstruments>

sr	=	48000
ksmps	=	4
nchnls	=	2
0dbfs	=	1

#include "m_loop_new.udo"
#include "m_loop_delete.udo"
#include "m_loop_save.udo"
#include "m_loop_valid.udo"
#include "m_loop_get_table.udo"
#include "m_loop_play.udo"

; Produce some live output and record it into a loop
instr Record
	; All about the input
	kamp line .8, p3, 0
	ainput vco2 kamp, 55, 0

	; Now sample it into the looper called s1
	kstat m_loop_new "s1", ainput
	; Play back the original
	outs ainput, ainput
endin

; Now playback from the looper
instr Play
	kPitch line 1, p3, 2
	iMode init 1 ; Playback backwards
	iRepeat init 3 ; repeat the sample three times
	iBegin init 0 ; playback from the beginning of the sample
	iEnd init 1 ; Playback to the real end of the sample
	aout m_loop_play "s1", kPitch, iMode, iRepeat, iBegin, iEnd

	; Save the sample to disk (s1.wav)
	istat m_loop_save "s1"

	; Get the validity/readiness of the sample/looper
	ivalid m_loop_valid "s1"
	; Get the internal ftable number of the looper
	ifn m_loop_get_table "s1"

	; Print validyt and ftable number
	prints "Validity: %d, tab: %d", ivalid, ifn

	; Delete the looper
	m_loop_delete "s1"
	outs aout, aout
endin

; Check that the looper is really deleted
instr Check
	iValid m_loop_valid "s1"
	prints "\nValidity after m_loop_delete: %d", iValid
endin

</CsInstruments>
; ==============================================
<CsScore>
i"Record" 0 1
i"Play" 2 3
i"Check" 5 .1
e
</CsScore>
</CsoundSynthesizer>
