/*
m_loop_save - Save a loop to disk as an audiofile

DESCRIPTION
m_loop_save will store the sample in this loop to disk. The file will be
called name.wav where name is the name of this loop.

SYNTAX
istatus m_loop_save Sname

INITIALIZATION
istatus - Output status, 0 on error
Sname - Name of the loop/sample (as given to m_loop_new)

PERFORMANCE

CREDITS
Author: Jeanette C.
*/

opcode m_loop_save, i, S
	Sname xin

	; Create basic channel name
	SchannelName strcat "m_loop.", Sname

	; Only perform if this loop is still valid
	if chnget(strcat(SchannelName, ".Valid")) == 1 then
		; create the filename to write
		Sfilename strcat Sname, ".wav"
		; Get the table number of the sample
		iSample chnget strcat(SchannelName, ".Table")

		iStatus ftaudio iSample, Sfilename, 16 ; write 32bit float wav file
	else ; invalid loop
		iStatus init 0
		prints "\nERROR m_loop_save %s: the loop is no longer valid. Was it deleted?", Sname
	endif

	xout iStatus
endop
